import os
import pandas as pd

# Read and prepare input data ..........................................................................................
here_path = os.path.dirname(os.path.realpath(__file__))

data_file_name = 'data_pylie_forecast_contest_2019_solution.csv'
data_file_path = os.path.join(here_path, data_file_name)
dfs = pd.read_csv(data_file_path, index_col=0)
dfs.index = pd.to_datetime(dfs.index)

# participant = 'mehdi'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/mahdikarimi/pylie-forecast-contest-2019/mahdikrimi_data_pylie_forecast_contest_2019.csv'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/mahdikarimi/2/pylie-forecast-contest-2019/mahdikrimi_data_pylie_forecast_contest_2019.csv'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/mahdikarimi/3/pylie-forecast-contest-2019/mahdikrimi_data_pylie_forecast_contest_2019.csv'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/mahdikarimi/4/pylie-forecast-contest-2019/mahdikrimi_data_pylie_forecast_contest_2019.csv'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/mahdikarimi/6/6pylie-forecast-contest-2019/pylie-forecast-contest-2019/mahhdikarimi_data_pylie_forecast_contest_2019.csv'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/mahdikarimi/7/pylie-forecast-contest-2019/mahdi_data_pylie_forecast_contest_2019.csv'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/mahdikarimi/8/pylie-forecast-contest-2019/mahdikrimi_data_pylie_forecast_contest_2019.csv'


# participant = 'emad'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/ezenthisiast/attachments/ezenthusiast_data_pylie_forecast_contest_2019.csv'


# participant = 'hosein'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/hossein_sharrahi/2/hossein_sharrahi/hossein_sharrahi_data_pylie_forecast_contest_2019.csv'


# participant = 'mohamadmehdi'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/mmreisi/1/MMReisi_data_pylie_forecast_contest_2019.csv'


# participant = 'erfan'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/1382erfan/2/1382Erfan_data_pylie_forecast_contest_2019.csv'


# participant = 'navid'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/navidazari/1/31121.csv'


# participant = 'nima'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/nima/nimare_data_pylie_forecast_contest_2019.csv'


# participant = 'parisa'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/parisa_m83/3/parisa_m83_data_pylie_forecast_contest_2019 (1)/parisa_m83_data_pylie_forecast_contest_2019.csv'


# participant = 'mobina-shadi'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/mobina_shadi_team/1/mobin_data_pylie_forecast_contest_2019.csv'


# participant = 'behfar-reza'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/behfar_reza/GFC2019/rezajalali & behfarbagheri data_pylie_forecast_contest_2019.csv'


# participant = 'mohamad-mahdyar'
# data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/azar_mahdyar/mohammadmahdi_data_pylie_forecast_contest-2019'

participant = 'test'
data_file_path = '/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/assessment/submissions/mobina_shadi_team/test/first_data_pylie_forecast_contest_2019.csv'

df = pd.read_csv(data_file_path, index_col=0)
df.index = pd.to_datetime(df.index)

# df['miya'] = df['miya_forecast']
# ......................................................................................................................

print(data_file_path.split('/')[-1])
print()

dfc = dfs['2027-04-01':'2027-04-07']['miya'] - df['2027-04-01':'2027-04-07']['miya']
# dfc = dfc.append(dfs['2027-07-01':'2027-07-10']['miya'] - df['2027-07-01':'2027-07-10']['miya'])
dfc = dfc.append(dfs['2027-10-01':'2027-10-07']['miya'] - df['2027-10-01':'2027-10-07']['miya'])

mse_public = (dfc).abs().mean()
print('mse_public = ' + str(round(mse_public, 1)))
print()

mse_final = (dfs['2027-01-01':'2028-01-01']['miya'] - df['2027-01-01':'2028-01-01']['miya']).abs().mean()
print('mse_final = ' + str(round(mse_final, 1)))

import matplotlib.pyplot as plt
plt.figure(figsize=(10,5))
dfs['2027-01-01':'2028-01-10']['miya'].plot(label='actual')
df['2027-01-01':'2028-01-10']['miya'].plot(label='forecast')
plt.title(participant + ' | ' + 'mse = ' + str(round(mse_final, 1)))
plt.ylim([2000, 12000])
plt.legend()
plt.tight_layout()
plt.savefig('/Users/aminrasekh/Google Drive/Pylie/Student_Contest/great-foreteller/final/reading/graphics/' + 'gfc-2019-plot-' + str(participant) + '.jpg', dpi=100)
plt.show()
